
drop database test
go

create database test
go

use test
go

-- 1. Simple self-signed cert
-- with expiration date of 1-year
create certificate foo
 encryption by password = 'Bar1234!'
 with subject = 'Foo'

-- look at its metadata
select * from sys.certificates

-- 2. create an asymmetric key from an executable file
-- unsafe assembly asymmetric keys go in master
use master
go

create asymmetric key unsafeasm_key
  from executable file = 'c:\temp\unsafeasm.dll'
go

-- or create from key file:
-- create asymmetric key unsafekey.snk
--   from file = 'C:\Documents and Settings\Administrator\My Documents\Visual Studio 2005\Projects\UnsafeAsm\unsafeasm.snk'

select * from sys.asymmetric_keys
go

create login unsafeasm_key
  from asymmetric key unsafeasm_key
go

grant unsafe assembly to unsafeasm_key
go

-- now you can catalog the assembly in a database
-- that's not marked as trustworthy
select name, is_trustworthy_on from sys.databases
go

create assembly unsafeasm 
  from 'c:\temp\unsafeasm.dll'
go

-- clean up

drop assembly unsafeasm
go

drop login unsafeasm_key
go


drop asymmetric key unsafeasm_key
go