
-- on the source server
-- remove database's master from master database
use clinicdb
go

alter master key drop encryption by service master key
go 

-- detach
use master
go
EXEC master.dbo.sp_detach_db @dbname = N'ClinicDB', 
     @keepfulltextindexfile=N'true'
GO

-- attach to other instance
-- placeholder only, actually do the disconnect, reconnect
:CONNECT ZMV17\SQL1

USE master
GO
CREATE DATABASE ClinicDB ON 
( FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\ClinicDB.mdf' ),
( FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\ClinicDB_log.LDF' )
 FOR ATTACH
GO
if not exists (select name from master.sys.databases sd where name = N'ClinicDB' and SUSER_SNAME(sd.owner_sid) = SUSER_SNAME() ) 
   EXEC [ClinicDB].dbo.sp_changedbowner @loginame=N'ZMV17\Administrator', @map=false
GO

-- try the "program" again
use clinicdb
go

-- 1. No login Doc1
CREATE LOGIN Doc1 WITH PASSWORD = 'StrongPW1'
GO

-- 2. No user for login Doc1
--    Fix it to link with LOGIN Doc1
sp_change_users_login 'Auto_Fix', 'Doc1'
GO

-- 3. Can't open master key
-- It is there, just needs connected in master
select * from sys.symmetric_keys

-- 4. Or I can manually open it
open master key decryption by password = 'ClinicDB1'
-- do stuff
close master key

-- 5. Or add encryption in master of the new instance
-- I need to have the master key open to do this
open master key decryption by password = 'ClinicDB1'
alter master key add encryption by service master key
go 

-- now it works again

execute as user = 'Doc1'

--open the relevant keys for usage
open symmetric key Doc1Key decryption by certificate Doc1Cert

--select from the table including decrypting from 
--encrypted columns
select Id, name, Docname, 
convert(varchar,decryptbykey(SSN)) as SSN,
convert (varchar,decryptbykey(Problem)) as Ailment 
from PatientTable

--simulate logging out
close all symmetric keys
revert

-- drop the database
drop database clinicdb
go
