use master
go

select * from sys.symmetric_keys
go

backup master key to file = 'c:\temp\clinic_master_key.key'
 encryption by password = 'StrongPW1'

-- the password for the master key when it was backed up 
-- was 'ClinicDB1'
restore master key from file = 'c:\temp\clinic_master_key.key'
 decryption by password = 'StrongPW1'
 encryption by password = 'StrongPW1'

-- this works now
open master key decryption by password = 'StrongPW1'
close master key

-- this doesn't 
open master key decryption by password = 'ClinicDB1'
close master key

-- the test with the doctor and auto-open works
execute as user = 'Doc1'
--open the relevant keys for usage
open symmetric key Doc1Key decryption by certificate Doc1Cert
--select from the table including decrypting from 
--encrypted columns
select Id, name, Docname, 
convert(varchar,decryptbykey(SSN)) as SSN,
convert (varchar,decryptbykey(Problem)) as Ailment 
from PatientTable
--simulate logging out
close all symmetric keys
revert

-- first backup, then disable auto-opening
backup master key to file = 'c:\temp\clinic_master_key2.key'
 encryption by password = 'StrongPW2'

alter master key drop encryption by service master key
close master key


-- Msg 15329, Level 16, State 30, Line 1
-- The current master key cannot be decrypted. 
-- If this is a database master key, you should attempt to open it in the session before performing this operation. The FORCE option can be used to ignore this error and continue the operation but the data encrypted by the old master key will be lost.
restore master key from file = 'c:\temp\clinic_master_key2.key'
 decryption by password = 'StrongPW2'
 encryption by password = 'StrongPW2'

-- The current master key cannot be decrypted. 
-- The error was ignored because the FORCE option was specified.
restore master key from file = 'c:\temp\clinic_master_key2.key'
 decryption by password = 'StrongPW2'
 encryption by password = 'StrongPW2'
 force

open master key decryption by password = 'StrongPW2'
go

-- the test with the doctors worked after manual open with new password
execute as user = 'Doc1'
--open the relevant keys for usage
open symmetric key Doc1Key decryption by certificate Doc1Cert
--select from the table including decrypting from 
--encrypted columns
select Id, name, Docname, 
convert(varchar,decryptbykey(SSN)) as SSN,
convert (varchar,decryptbykey(Problem)) as Ailment 
from PatientTable
--simulate logging out
close all symmetric keys
revert

close master key

-- this works too, after Doc1 auto-open works
open master key decryption by password = 'StrongPW2'
alter master key add encryption by service master key

-- try to set master key on another database
use pubs

restore master key from file = 'c:\temp\clinic_master_key2.key'
 decryption by password = 'StrongPW2'
 encryption by password = 'StrongPW2'

-- needs master key, pubs database
create asymmetric key foo with algorithm = rsa_512 

open master key decryption by password = 'StrongPW2'
-- now this works
create asymmetric key foo with algorithm = rsa_512 